## kdevplatform 5.0.3

=== CMakeLists.txt ===
# kdevplatform version
set(KDEVPLATFORM_VERSION_MAJOR 5)
set(KDEVPLATFORM_VERSION_MINOR 0)
set(KDEVPLATFORM_VERSION_PATCH 3)

# plugin versions listed in the .desktop files
set(KDEV_PLUGIN_VERSION 25)
# Increase this to reset incompatible item-repositories
set(KDEV_ITEMREPOSITORY_VERSION 85)

# library version / SO version
set(KDEVPLATFORM_LIB_VERSION 10.0.0)
set(KDEVPLATFORM_LIB_SOVERSION 10)

################################################################################

cmake_minimum_required(VERSION 2.8.12)
project(KDevPlatform)

# we need some parts of the ECM CMake helpers
find_package (ECM 0.0.9 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${KDevPlatform_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMAddTests)
include(ECMOptionalAddSubdirectory)
include(ECMInstallIcons)
include(ECMSetupVersion)
include(ECMMarkAsTest)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(ECMPackageConfigHelpers)
include(GenerateExportHeader)
include(FeatureSummary)
include(WriteBasicConfigVersionFile)
include(CheckFunctionExists)
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDevPlatformMacros)

set(QT_MIN_VERSION "5.4.0")
find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED Core DBus Widgets WebKitWidgets Concurrent Test)

find_package(Qt5QuickWidgets ${QT_MIN_VERSION})
set_package_properties(Qt5QuickWidgets PROPERTIES
    PURPOSE "Qt5 QuickWidgets library (part of Qt >=5.3). Required for the Welcome Page plugin."
)

set(KF5_DEP_VERSION "5.16.0")
find_package(KF5 ${KF5_DEP_VERSION} REQUIRED COMPONENTS
  Archive
  Config
  GuiAddons
  WidgetsAddons
  IconThemes
  I18n
  ItemModels
  ItemViews
  JobWidgets
  KCMUtils
  KIO
  NewStuff
  Notifications
  NotifyConfig
  Parts
  Service
  Sonnet
  TextEditor
  ThreadWeaver
  WindowSystem
  Declarative
  XmlGui
)

find_package(Grantlee5)
set_package_properties(Grantlee5 PROPERTIES
    PURPOSE "Grantlee templating library, needed for file templates"
    URL "http://www.grantlee.org/"
    TYPE RECOMMENDED)

set(Boost_ADDITIONAL_VERSIONS 1.39.0 1.39)
find_package(Boost 1.35.0)
set_package_properties(Boost PROPERTIES
    PURPOSE "Boost libraries for enabling the classbrowser"
    URL "http://www.boost.org"
    TYPE REQUIRED)

add_definitions(
    -DQT_DEPRECATED_WARNINGS
    -DQT_DISABLE_DEPRECATED_BEFORE=0x050400
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_STRICT_ITERATORS
    -DQT_USE_FAST_CONCATENATION
    -DQT_USE_FAST_OPERATOR_PLUS
)

# Turn off missing-field-initializers warning for GCC to avoid noise from false positives with empty {}
# See discussion: http://mail.kde.org/pipermail/kdevelop-devel/2014-February/046910.html
check_cxx_compiler_flag(-Wno-missing-field-initializers HAVE_MFI_FLAG)
check_cxx_compiler_flag(-Werror=undefined-bool-conversion HAVE_UBC_FLAG)
check_cxx_compiler_flag(-Werror=tautological-undefined-compare HAVE_TUC_FLAG)
if (HAVE_MFI_FLAG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-field-initializers")
endif()
if (HAVE_UBC_FLAG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=undefined-bool-conversion")
endif()
if (HAVE_TUC_FLAG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=tautological-undefined-compare")
endif()

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/config-kdevplatform.h.cmake
                ${CMAKE_CURRENT_BINARY_DIR}/config-kdevplatform.h )

include_directories(${KDevPlatform_SOURCE_DIR} ${KDevPlatform_BINARY_DIR})

string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER)
if(CMAKE_BUILD_TYPE_TOLOWER MATCHES "debug"
  OR CMAKE_BUILD_TYPE_TOLOWER STREQUAL "")
  set(COMPILER_OPTIMIZATIONS_DISABLED TRUE)
else()
  set(COMPILER_OPTIMIZATIONS_DISABLED FALSE)
endif()

add_subdirectory(sublime)
add_subdirectory(interfaces)
add_subdirectory(project)
add_subdirectory(language)
add_subdirectory(shell)
add_subdirectory(util)
add_subdirectory(outputview)
add_subdirectory(vcs)
add_subdirectory(pics)
add_subdirectory(debugger)
add_subdirectory(documentation)
add_subdirectory(serialization)
add_subdirectory(template)
add_subdirectory(tests)
add_subdirectory(plugins)

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KDevPlatform")

ecm_configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KDevPlatformConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/KDevPlatformConfig.cmake"
                              INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
)

ecm_setup_version(${KDEVPLATFORM_VERSION_MAJOR}.${KDEVPLATFORM_VERSION_MINOR}.${KDEVPLATFORM_VERSION_PATCH}
                  VARIABLE_PREFIX KDEVPLATFORM
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdevplatform_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDevPlatformConfigVersion.cmake"
                  SOVERSION ${KDEVPLATFORM_LIB_SOVERSION})

install( FILES
        "${KDevPlatform_BINARY_DIR}/kdevplatform_version.h"
        "${KDevPlatform_BINARY_DIR}/config-kdevplatform.h"
        DESTINATION "${KDE_INSTALL_INCLUDEDIR}/kdevplatform" )
install( FILES
        "${KDevPlatform_BINARY_DIR}/KDevPlatformConfig.cmake"
        "${KDevPlatform_BINARY_DIR}/KDevPlatformConfigVersion.cmake"
        cmake/modules/KDevPlatformMacros.cmake
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}" )
install( EXPORT KDevPlatformTargets
         DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
         NAMESPACE KDev::
         FILE KDevPlatformTargets.cmake )

include(CTest)

# CTestCustom.cmake has to be in the CTEST_BINARY_DIR.
# in the KDE build system, this is the same as CMAKE_BINARY_DIR.
configure_file(${CMAKE_SOURCE_DIR}/CTestCustom.cmake ${CMAKE_BINARY_DIR}/CTestCustom.cmake)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

=== outputview/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevplatform\")

set(outputviewinterfaces_LIB_SRCS
    outputdelegate.cpp
    outputformats.cpp
    filtereditem.cpp
    ifilterstrategy.cpp
    outputmodel.cpp
    ioutputview.cpp
    ioutputviewmodel.cpp
    outputfilteringstrategies.cpp
    outputjob.cpp
    outputexecutejob.cpp
)
kdevplatform_add_library(KDevPlatformOutputView SOURCES ${outputviewinterfaces_LIB_SRCS})
target_link_libraries(KDevPlatformOutputView PRIVATE
    Qt5::Core
    KDev::Interfaces
    KDev::Util
)

install(FILES
    ioutputview.h
    filtereditem.h
    outputmodel.h
    outputdelegate.h
    outputfilteringstrategies.h
    ioutputviewmodel.h
    ifilterstrategy.h
    outputjob.h
    outputexecutejob.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/outputview COMPONENT Devel)

add_subdirectory(tests)

=== pics/CMakeLists.txt ===
install(DIRECTORY 22x22 DESTINATION ${KDE_INSTALL_ICONDIR}/hicolor)
install(DIRECTORY 16x16 DESTINATION ${KDE_INSTALL_ICONDIR}/hicolor)

=== plugins/CMakeLists.txt ===
ecm_optional_add_subdirectory(konsole)
add_subdirectory(filemanager)
if (Grantlee5_FOUND)
    add_subdirectory(appwizard)
endif()
add_subdirectory(projectmanagerview)
add_subdirectory(genericprojectmanager)
add_subdirectory(standardoutputview)
add_subdirectory(documentview)
add_subdirectory(quickopen)
add_subdirectory(executescript)
add_subdirectory(contextbrowser)
ecm_optional_add_subdirectory(cvs)
add_subdirectory(problemreporter)
add_subdirectory(execute)
add_subdirectory(externalscript)
add_subdirectory(documentswitcher)
add_subdirectory(patchreview)
add_subdirectory(openwith)
add_subdirectory(grepview)
add_subdirectory(git)
add_subdirectory(bazaar)
add_subdirectory(vcschangesview)
if (Grantlee5_FOUND)
    add_subdirectory(filetemplates)
    add_subdirectory(codeutils)
endif()
add_subdirectory(testview)
add_subdirectory(switchtobuddy)
add_subdirectory(projectfilter)
if (Qt5QuickWidgets_FOUND)
    add_subdirectory(welcomepage)
endif()
add_subdirectory(outlineview)

ecm_optional_add_subdirectory(classbrowser)

find_package(SubversionLibrary)
set_package_properties(SubversionLibrary PROPERTIES
    PURPOSE "Support for Subversion integration"
    URL "http://subversion.tigris.org"
    TYPE OPTIONAL)

if(SubversionLibrary_FOUND)
    ecm_optional_add_subdirectory(subversion)
endif()

=== project/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevplatform\")

set(KDevPlatformProject_LIB_SRCS
    projectutils.cpp
    projectmodel.cpp
    projectchangesmodel.cpp
    projectconfigskeleton.cpp
    importprojectjob.cpp
    builderjob.cpp
    projectbuildsetmodel.cpp
    projectitemlineedit.cpp
    helper.cpp
    debug.cpp
    projectproxymodel.cpp
    abstractfilemanagerplugin.cpp
    filemanagerlistjob.cpp
    projectfiltermanager.cpp
    interfaces/iprojectbuilder.cpp
    interfaces/iprojectfilemanager.cpp
    interfaces/ibuildsystemmanager.cpp
    interfaces/iprojectfilter.cpp
    interfaces/iprojectfilterprovider.cpp
)

kdevplatform_add_library(KDevPlatformProject SOURCES ${KDevPlatformProject_LIB_SRCS})
target_link_libraries(KDevPlatformProject
LINK_PUBLIC
    KDev::Interfaces
    KDev::Util # util/path.h
LINK_PRIVATE
    KDev::Interfaces
    KDev::Serialization
    KDev::Vcs
    KF5::KIOWidgets
    Qt5::Concurrent
)

add_subdirectory(tests)

install(FILES
    interfaces/iprojectbuilder.h
    interfaces/iprojectfilemanager.h
    interfaces/ibuildsystemmanager.h
    interfaces/iprojectfilter.h
    interfaces/iprojectfilterprovider.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/project/interfaces COMPONENT Devel
)

install(FILES
    projectutils.h
    importprojectjob.h
    projectchangesmodel.h
    projectconfigskeleton.h
    projectmodel.h
    projectconfigpage.h
    projectitemlineedit.h
    projectbuildsetmodel.h
    builderjob.h
    helper.h
    abstractfilemanagerplugin.h
    projectfiltermanager.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/project COMPONENT Devel
)

=== shell/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevplatform\")

add_subdirectory(tests)

set(KDevPlatformShell_LIB_SRCS
    workingsetcontroller.cpp
    workingsets/workingset.cpp
    workingsets/workingsetfilelabel.cpp
    workingsets/workingsettoolbutton.cpp
    workingsets/workingsettooltipwidget.cpp
    workingsets/workingsetwidget.cpp
    workingsets/closedworkingsetswidget.cpp
    workingsets/workingsethelpers.cpp
    mainwindow.cpp
    mainwindow_p.cpp
    plugincontroller.cpp
    ktexteditorpluginintegration.cpp
    shellextension.cpp
    core.cpp
    uicontroller.cpp
    projectcontroller.cpp
    project.cpp
    partcontroller.cpp
    #document.cpp
    partdocument.cpp
    textdocument.cpp
    documentcontroller.cpp
    languagecontroller.cpp
    statusbar.cpp
    runcontroller.cpp
    unitylauncher.cpp
    sessioncontroller.cpp
    session.cpp
    sessionlock.cpp
    sessionchooserdialog.cpp
    savedialog.cpp
    sourceformattercontroller.cpp
    completionsettings.cpp
    openprojectpage.cpp
    openprojectdialog.cpp
    projectinfopage.cpp
    selectioncontroller.cpp
    documentationcontroller.cpp
    debugcontroller.cpp
    launchconfiguration.cpp
    launchconfigurationdialog.cpp
    loadedpluginsdialog.cpp
    testcontroller.cpp
    projectsourcepage.cpp
    debug.cpp
    configdialog.cpp
    editorconfigpage.cpp
    environmentconfigurebutton.cpp

    checkerstatus.cpp
    problem.cpp
    problemmodelset.cpp
    problemmodel.cpp
    problemstore.cpp
    watcheddocumentset.cpp
    filteredproblemstore.cpp

    progresswidget/progressmanager.cpp
    progresswidget/statusbarprogresswidget.cpp
    progresswidget/overlaywidget.cpp
    progresswidget/progressdialog.cpp

    areadisplay.cpp

    settings/uipreferences.cpp
    settings/pluginpreferences.cpp
    settings/sourceformattersettings.cpp
    settings/editstyledialog.cpp
    settings/projectpreferences.cpp
    settings/environmentwidget.cpp
    settings/environmentgroupmodel.cpp
    settings/environmentpreferences.cpp
    settings/languagepreferences.cpp
    settings/bgpreferences.cpp
    settings/templateconfig.cpp
    settings/templatepage.cpp

)

kconfig_add_kcfg_files(KDevPlatformShell_LIB_SRCS
    settings/uiconfig.kcfgc
    settings/projectconfig.kcfgc
    settings/languageconfig.kcfgc
    settings/bgconfig.kcfgc
)

ki18n_wrap_ui(KDevPlatformShell_LIB_SRCS
    projectinfopage.ui
    launchconfigurationdialog.ui
    projectsourcepage.ui
    settings/uiconfig.ui
    settings/editstyledialog.ui
    settings/sourceformattersettings.ui
    settings/projectpreferences.ui
    settings/environmentwidget.ui
    settings/languagepreferences.ui
    settings/bgpreferences.ui
    settings/templateconfig.ui
    settings/templatepage.ui
)

qt5_add_resources(KDevPlatformShell_LIB_SRCS kdevplatformshell.qrc)
kdevplatform_add_library(KDevPlatformShell SOURCES ${KDevPlatformShell_LIB_SRCS})
target_link_libraries(KDevPlatformShell
LINK_PUBLIC
    KF5::XmlGui

    KDev::Sublime
    KDev::OutputView
    KDev::Interfaces
LINK_PRIVATE
    Qt5::Quick
    Qt5::QuickWidgets

    KF5::GuiAddons
    KF5::IconThemes
    KF5::KIOFileWidgets
    KF5::KIOWidgets
    KF5::Parts
    KF5::Notifications
    KF5::NotifyConfig
    KF5::TextEditor
    KF5::ThreadWeaver
    KF5::JobWidgets
    KF5::ItemViews
    KF5::WindowSystem
    KF5::KCMUtils #for KPluginSelector, not sure why it is in kcmutils
    KF5::NewStuff # template config page
    KF5::Archive # template config page

    KDev::Debugger
    KDev::Project
    KDev::Vcs
    KDev::Language
    KDev::Util
    KDev::Documentation
)

install(FILES
    mainwindow.h
    plugincontroller.h
    shellextension.h
    core.h
    uicontroller.h
    projectcontroller.h
    project.h
    partcontroller.h
    partdocument.h
    textdocument.h
    documentcontroller.h
    languagecontroller.h
    session.h
    sessioncontroller.h
    sessionlock.h
    sourceformattercontroller.h
    selectioncontroller.h
    runcontroller.h
    launchconfiguration.h
    environmentconfigurebutton.h
    checkerstatus.h
    problem.h
    problemmodel.h
    problemmodelset.h
    problemconstants.h
    filteredproblemstore.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/shell COMPONENT Devel
)

=== template/CMakeLists.txt ===
if(Grantlee5_FOUND)
  add_subdirectory(filters)
  add_subdirectory(templates)
endif()

=== vcs/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevplatform\")

add_subdirectory(dvcs/tests)
add_subdirectory(models/tests)

set(KDevPlatformVcs_UIS
    widgets/vcscommitdialog.ui
    widgets/vcseventwidget.ui
    widgets/vcsdiffwidget.ui
    dvcs/ui/dvcsimportmetadatawidget.ui
    dvcs/ui/branchmanager.ui
)

set(KDevPlatformVcs_LIB_SRCS
    vcsjob.cpp
    vcsrevision.cpp
    vcsannotation.cpp
    vcspluginhelper.cpp
    vcslocation.cpp
    vcsdiff.cpp
    vcsevent.cpp
    vcsstatusinfo.cpp
    debug.cpp
    widgets/vcsimportmetadatawidget.cpp
    widgets/vcseventwidget.cpp
    widgets/vcsdiffwidget.cpp
    widgets/vcscommitdialog.cpp
    widgets/vcsdiffpatchsources.cpp
    widgets/vcslocationwidget.cpp
    widgets/standardvcslocationwidget.cpp
    models/vcsannotationmodel.cpp
    models/vcseventmodel.cpp
    models/vcsfilechangesmodel.cpp
    models/vcsitemeventmodel.cpp
    models/brancheslistmodel.cpp
    dvcs/dvcsjob.cpp
    dvcs/dvcsplugin.cpp
    dvcs/ui/dvcsimportmetadatawidget.cpp
    dvcs/ui/branchmanager.cpp
    dvcs/ui/revhistory/commitView.cpp
    dvcs/ui/revhistory/commitlogmodel.cpp
    interfaces/ibasicversioncontrol.cpp
    interfaces/icontentawareversioncontrol.cpp
    interfaces/ipatchdocument.cpp
    interfaces/ipatchsource.cpp
)
ki18n_wrap_ui(KDevPlatformVcs_LIB_SRCS ${KDevPlatformVcs_UIS})
kdevplatform_add_library(KDevPlatformVcs SOURCES ${KDevPlatformVcs_LIB_SRCS})
target_link_libraries(KDevPlatformVcs
LINK_PUBLIC
    KDev::OutputView
    KDev::Interfaces
LINK_PRIVATE
    KF5::KIOWidgets
    KF5::Parts
    KDev::Util
)

install(FILES
    vcsjob.h
    vcsrevision.h
    vcsannotation.h
    vcsdiff.h
    vcspluginhelper.h
    vcsevent.h
    vcsstatusinfo.h
    vcslocation.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/vcs COMPONENT Devel
)

install(FILES
    widgets/vcsimportmetadatawidget.h
    widgets/vcseventwidget.h
    widgets/vcsdiffwidget.h
    widgets/vcscommitdialog.h
    widgets/vcslocationwidget.h
    widgets/standardvcslocationwidget.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/vcs/widgets COMPONENT Devel
)


install(FILES
    models/vcsannotationmodel.h
    models/vcseventmodel.h
    models/vcsfilechangesmodel.h
    models/vcsitemeventmodel.h
    models/brancheslistmodel.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/vcs/models COMPONENT Devel
)

install(FILES
    interfaces/ibasicversioncontrol.h
    interfaces/icentralizedversioncontrol.h
    interfaces/idistributedversioncontrol.h
    interfaces/ibranchingversioncontrol.h
    interfaces/ibrowsableversioncontrol.h
    interfaces/irepositoryversioncontrol.h
    interfaces/ipatchdocument.h
    interfaces/ipatchsource.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/vcs/interfaces COMPONENT Devel
)

install(FILES
    dvcs/dvcsjob.h
    dvcs/dvcsplugin.h
    dvcs/dvcsevent.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/vcs/dvcs COMPONENT Devel
)

install(FILES
    dvcs/ui/dvcsimportmetadatawidget.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/vcs/dvcs/ui COMPONENT Devel
)

=== plugins/bazaar/CMakeLists.txt ===
project(bazaar)

set(kdevbazaar_SRCS
    diffjob.cpp
    bzrannotatejob.cpp
    bazaarplugin.cpp
    bazaarpluginmetadata.cpp
    bazaarutils.cpp
    copyjob.cpp
)

kdevplatform_add_plugin(kdevbazaar JSON kdevbazaar.json SOURCES ${kdevbazaar_SRCS})

target_link_libraries(kdevbazaar
    KDev::Vcs
)

add_subdirectory(icons)
add_subdirectory(tests)

=== plugins/contextbrowser/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevcontextbrowser\")

########### next target ###############

set(kdevcontextbrowser_PART_SRCS
    contextbrowser.cpp
    contextbrowserview.cpp
    browsemanager.cpp
)

qt5_add_resources(kdevcontextbrowser_PART_SRCS kdevcontextbrowser.qrc)
kdevplatform_add_plugin(kdevcontextbrowser JSON kdevcontextbrowser.json SOURCES ${kdevcontextbrowser_PART_SRCS})

target_link_libraries(kdevcontextbrowser KDev::Interfaces KDev::Util KDev::Language KDev::Sublime KF5::TextEditor KF5::Parts)

=== plugins/cvs/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevcvs\")
add_subdirectory(tests)


########### next target ###############

set(kdevcvs_PART_SRCS
    cvsplugin.cpp
    cvsmainview.cpp
    cvsgenericoutputview.cpp
    cvsjob.cpp
    cvsproxy.cpp
    editorsview.cpp
    commitdialog.cpp
    importmetadatawidget.cpp
    importdialog.cpp
    checkoutdialog.cpp
    cvsannotatejob.cpp
    cvslogjob.cpp
    cvsdiffjob.cpp
    cvsstatusjob.cpp
)

set(kdevcvs_PART_UI
    cvsmainview.ui
    cvsgenericoutputview.ui
    editorsview.ui
    commitdialog.ui
    importmetadatawidget.ui
    checkoutdialog.ui
)

ki18n_wrap_ui(kdevcvs_PART_SRCS ${kdevcvs_PART_UI})

qt5_add_resources(kdevcvs_PART_SRCS kdevcvs.qrc)
kdevplatform_add_plugin(kdevcvs JSON kdevcvs.json SOURCES ${kdevcvs_PART_SRCS})

target_link_libraries(kdevcvs
    KF5::KIOWidgets
    KF5::Parts
    KDev::Util
    KDev::Interfaces
    KDev::Vcs
    KDev::Project
    KDev::Language
)

=== plugins/documentswitcher/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevdocumentswitcher\")
project(documentswitcher)

########### next target ###############

set(kdevdocumentswitcher_PART_SRCS
    documentswitcherplugin.cpp
    documentswitchertreeview.cpp
)

qt5_add_resources(kdevdocumentswitcher_PART_SRCS kdevdocumentswitcher.qrc)
kdevplatform_add_plugin(kdevdocumentswitcher JSON kdevdocumentswitcher.json SOURCES ${kdevdocumentswitcher_PART_SRCS})

target_link_libraries(kdevdocumentswitcher KDev::Interfaces KDev::Sublime KDev::Interfaces KDev::Util KDev::Project )

=== debian/changelog ===
kdevplatform (5.0.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Sat, 07 Jan 2017 15:43:27 -0300

kdevplatform (5.0.1-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Override dh_makeshlibs to generate a shlibs dependency for the current
    version.

 -- Pino Toscano <pino@debian.org>  Tue, 20 Sep 2016 22:54:28 +0200

kdevplatform (5.0.1-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the patches:
    - upstream_find-all-dependencies.patch: drop, backported from upstream
  * Replace the kio-dev (transitional) (build) dependency with libkf5kio-dev.
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Mon, 19 Sep 2016 22:22:56 +0200

kdevplatform (5.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release:
    - switches from Qt4 (using QtWebKit) to Frameworks (Closes: #784484)
    - the kdevplatform_create_template_archive CMake macro invokes tar in a
      reproducible way (Closes: #815962)
  * Update the build dependencies following the port to Frameworks:
    - remove kdelibs5-dev, libgrantlee-dev, libqjson-dev, libqtwebkit-dev
    - add extra-cmake-modules, qtbase5-dev, qtdeclarative5-dev,
      libqt5webkit5-dev, libkf5archive-dev, libkf5config-dev,
      libkf5guiaddons-dev, libkf5declarative-dev, libkf5i18n-dev,
      libkf5iconthemes-dev, libkf5itemmodels-dev, libkf5itemviews-dev,
      libkf5jobwidgets-dev, libkf5kcmutils-dev, kio-dev, libkf5newstuff-dev,
      libkf5notifications-dev, libkf5notifyconfig-dev, libkf5parts-dev,
      libkf5service-dev, libkf5sonnet-dev, libkf5texteditor-dev,
      libkf5threadweaver-dev, libkf5windowsystem-dev, libkf5widgetsaddons-dev,
      libkf5xmlgui-dev, libgrantlee5-dev, and libkomparediff2-dev
  * Use the right dh addon:
    - switch from kde to kf5 dh addon
    - bump the pkg-kde-tools build dependency to >= 0.15.16
  * Rename packages according to the SONAME bumps:
    - kdevplatform8-libs -> kdevplatform10-libs
    - libsublime8 -> libsublime10
  * Update the patches:
    - 11_disable_examples_tests.diff: drop, no more needed
    - upstream_filetemplates-plugin-Make-testfiletemplates-depend-o.patch:
      drop, backported from upstream
  * Update install files.
  * Add in kdevplatform10-libs breaks/replaces against old kdevplatform8-libs.
  * Backport upstream commit b64f24d70164c65805e3fff965478a21fd74326b to fix
    dependencies in the cmake configuration files; patch
    upstream_find-all-dependencies.patch.
  * Disable building of unit tests, as long as they are not run.
  * Manually add -dev dependencies in kdevplatform-dev and libsublime-dev,
    for now.
  * Update lintian overrides.
  * Fold the Sublime library into the main library and -dev packages, as the
    split is no more worth:
    - install the content of libsublime10 into kdevplatform10-libs
    - install the content of libsublime-dev into kdevplatform-dev, adding
      proper breaks/replaces
    - drop the libsublime10 and libsublime-dev binaries
  * Remove dh_makeshlibs override in rules, no more needed.
  * Raise the kdevelop and kdevelop-data breaks in kdevplatform10-libs to
    versions lower than 5.0.

 -- Pino Toscano <pino@debian.org>  Fri, 26 Aug 2016 20:33:08 +0200

kdevplatform (1.7.3-3) unstable; urgency=medium

  * Team upload.
  * Backport upstream commit dd18e9a13558cbe519c382d3fe358ae97e39cd38 to fix
    build without parallel jobs; patch
    upstream_filetemplates-plugin-Make-testfiletemplates-depend-o.patch.
    (Closes: #821805)
  * Remove kdevplatform-dbg in favour of the -dbgsym packages.
  * Bump Standards-Version to 3.9.8, no changes required.

 -- Pino Toscano <pino@debian.org>  Mon, 06 Jun 2016 22:13:52 +0200

kdevplatform (1.7.3-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Thu, 26 May 2016 17:26:25 -0300

kdevplatform (1.7.3-1) experimental; urgency=medium

  * Team upload.
  * New upstream release (Closes: #821805).
  * Make uscan:
    - Look for different compression methods, as it seems they might change.
    - Repack the source with xz compression.
  * Update Standards-Version to 3.9.7, no changes required.
  * Update Vcs-[Browser Git] to their https versions.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Sat, 30 Apr 2016 11:58:21 -0300

=== debian/control ===
Source: kdevplatform
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Fathi Boudra <fabo@debian.org>,
           Jeremy Lainé <jeremy.laine@m4x.org>,
           George Kiagiadakis <kiagiadakis.george@gmail.com>,
           Andreas Cord-Landwehr <cola@uni-paderborn.de>
Build-Depends: cmake (>= 2.8.9~),
               debhelper (>= 9),
               extra-cmake-modules (>= 0.0.9),
               qtbase5-dev (>= 5.4.0),
               qtdeclarative5-dev (>= 5.4.0),
               libqt5webkit5-dev (>= 5.4.0),
               libkf5archive-dev (>= 5.16.0),
               libkf5config-dev (>= 5.16.0),
               libkf5guiaddons-dev (>= 5.16.0),
               libkf5declarative-dev (>= 5.16.0),
               libkf5i18n-dev (>= 5.16.0),
               libkf5iconthemes-dev (>= 5.16.0),
               libkf5itemmodels-dev (>= 5.16.0),
               libkf5itemviews-dev (>= 5.16.0),
               libkf5jobwidgets-dev (>= 5.16.0),
               libkf5kcmutils-dev (>= 5.16.0),
               libkf5kio-dev (>= 5.16.0),
               libkf5newstuff-dev (>= 5.16.0),
               libkf5notifications-dev (>= 5.16.0),
               libkf5notifyconfig-dev (>= 5.16.0),
               libkf5parts-dev (>= 5.16.0),
               libkf5service-dev (>= 5.16.0),
               libkf5sonnet-dev (>= 5.16.0),
               libkf5texteditor-dev (>= 5.16.0),
               libkf5threadweaver-dev (>= 5.16.0),
               libkf5windowsystem-dev (>= 5.16.0),
               libkf5widgetsaddons-dev (>= 5.16.0),
               libkf5xmlgui-dev (>= 5.16.0),
               libgrantlee5-dev,
               libkomparediff2-dev,
               libboost-serialization-dev,
               libsvn-dev,
               pkg-kde-tools (>= 0.15.16),
Standards-Version: 3.9.8
Homepage: http://www.kdevelop.org/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-std/kdevplatform.git
Vcs-Git: https://anonscm.debian.org/git/pkg-kde/kde-std/kdevplatform.git

Package: kdevplatform10-libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: kdevelop (<< 4:5.0),
          kdevelop-data (<< 4:5.0),
          kdevplatform1-libs,
          kdevplatform2-libs,
          kdevplatform3-libs,
          kdevplatform5-libs,
          kdevplatform7-libs,
          kdevplatform8-libs,
Breaks: kdevplatform1-libs,
        kdevplatform2-libs,
        kdevplatform3-libs,
        kdevplatform5-libs,
        kdevplatform7-libs,
        kdevplatform8-libs,
Suggests: cvs, git, kdevplatform-l10n, konsole
Description: shared libraries for the KDevelop platform
 This package contains shared libraries needed to run integrated development
 environments based on the KDevelop platform.
 .
 This package is part of the KDevelop platform.

Package: kdevplatform-dev
Section: libdevel
Architecture: any
Depends: kdevplatform10-libs (= ${binary:Version}),
         ${misc:Depends},
         qtbase5-dev (>= 5.4.0),
         qtdeclarative5-dev (>= 5.4.0),
         libkf5archive-dev (>= 5.16.0),
         libkf5config-dev (>= 5.16.0),
         libkf5guiaddons-dev (>= 5.16.0),
         libkf5i18n-dev (>= 5.16.0),
         libkf5iconthemes-dev (>= 5.16.0),
         libkf5itemviews-dev (>= 5.16.0),
         libkf5jobwidgets-dev (>= 5.16.0),
         libkf5kcmutils-dev (>= 5.16.0),
         libkf5kio-dev (>= 5.16.0),
         libkf5newstuff-dev (>= 5.16.0),
         libkf5notifications-dev (>= 5.16.0),
         libkf5notifyconfig-dev (>= 5.16.0),
         libkf5parts-dev (>= 5.16.0),
         libkf5service-dev (>= 5.16.0),
         libkf5texteditor-dev (>= 5.16.0),
         libkf5threadweaver-dev (>= 5.16.0),
         libkf5windowsystem-dev (>= 5.16.0),
         libgrantlee5-dev,
Breaks: libsublime-dev (<< 5.0)
Replaces: libsublime-dev (<< 5.0)
Description: development files for the KDevelop platform
 This package contains development files for building integrated development
 environments based on the KDevelop platform.
 .
 This package is part of the KDevelop platform.

Package: kdevplatform-l10n
Section: localization
Architecture: all
Depends: ${misc:Depends}
Replaces: kdevplatform-l10n-ca,
          kdevplatform-l10n-cavalencia,
          kdevplatform-l10n-da,
          kdevplatform-l10n-de,
          kdevplatform-l10n-engb,
          kdevplatform-l10n-es,
          kdevplatform-l10n-et,
          kdevplatform-l10n-fi,
          kdevplatform-l10n-fr,
          kdevplatform-l10n-gl,
          kdevplatform-l10n-hu,
          kdevplatform-l10n-it,
          kdevplatform-l10n-nds,
          kdevplatform-l10n-nl,
          kdevplatform-l10n-pt,
          kdevplatform-l10n-ptbr,
          kdevplatform-l10n-ru,
          kdevplatform-l10n-sl,
          kdevplatform-l10n-sv,
          kdevplatform-l10n-th,
          kdevplatform-l10n-tr,
          kdevplatform-l10n-uk,
          kdevplatform-l10n-zhcn,
          kdevplatform-l10n-zhtw
Breaks: kdevplatform-l10n-ca,
        kdevplatform-l10n-cavalencia,
        kdevplatform-l10n-da,
        kdevplatform-l10n-de,
        kdevplatform-l10n-engb,
        kdevplatform-l10n-es,
        kdevplatform-l10n-et,
        kdevplatform-l10n-fi,
        kdevplatform-l10n-fr,
        kdevplatform-l10n-gl,
        kdevplatform-l10n-hu,
        kdevplatform-l10n-it,
        kdevplatform-l10n-nds,
        kdevplatform-l10n-nl,
        kdevplatform-l10n-pt,
        kdevplatform-l10n-ptbr,
        kdevplatform-l10n-ru,
        kdevplatform-l10n-sl,
        kdevplatform-l10n-sv,
        kdevplatform-l10n-th,
        kdevplatform-l10n-tr,
        kdevplatform-l10n-uk,
        kdevplatform-l10n-zhcn,
        kdevplatform-l10n-zhtw
Suggests: kde-l10n
Description: language package for the KDevelop platform
 This package contains the localization files for applications using
 the KDevelop platform.
 .
 This package is part of the KDevelop platform.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@ --parallel --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF

override_dh_install:
	dh_install --list-missing

override_dh_strip:
	dh_strip --dbgsym-migration='kdevplatform-dbg (<< 1.7.3-3~)'

override_dh_makeshlibs:
	dh_makeshlibs -V

override_dh_shlibdeps:
	dh_shlibdeps
	dh_sameversiondep

.PHONY: override_dh_auto_test

=== debian/watch ===
version=3
opts="repack,compression=xz"
http://download.kde.org/stable/kdevelop/([\d.]+)/src/kdevplatform-([\d.]+).tar.(?:xz|bz2|gz)

## kdevplatform 5.0.4

=== debian/changelog ===
kdevplatform (5.0.4-0ubuntu1) zesty; urgency=medium

  * New upstream bugfix release (5.0.4)

 -- Rik Mills <rikmills@kubuntu.org>  Wed, 15 Mar 2017 08:09:07 +0000

kdevplatform (5.0.3-0ubuntu2) zesty; urgency=medium

  * Clean up packaging from 5.0.3-0ubuntu1
  * Sync with Debian. Remaining changes:
    - Add autopkgtest
  * New upstream bugfix release
  * debian/kdevplatform10-libs.install:
    - Install breakpoint icons

 -- Jeremy Bicha <jbicha@ubuntu.com>  Mon, 26 Dec 2016 15:24:14 -0500

kdevplatform (5.0.3-0ubuntu1) zesty; urgency=medium

  [ Ovidiu-Florin Bogdan ]
  * Merged with debian experimental

  [ Clive Johnston ]
  * New upstream release (5.0.1)
  * New upstream release (5.0.2)
  * New upstream release (5.0.3)

 -- Clive Johnston <clivejo@kubuntu.org>  Mon, 26 Dec 2016 15:30:44 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: kdevplatform
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Fathi Boudra <fabo@debian.org>,
            Jeremy Lainé <jeremy.laine@m4x.org>,
            George Kiagiadakis <kiagiadakis.george@gmail.com>,
@@ -9,20 +9,19 @@
 Build-Depends: cmake (>= 2.8.9~),
                debhelper (>= 9),
                extra-cmake-modules (>= 0.0.9),
-               qtbase5-dev (>= 5.4.0),
-               qtdeclarative5-dev (>= 5.4.0),
-               libqt5webkit5-dev (>= 5.4.0),
+               kio-dev (>= 5.16.0),
+               libboost-serialization-dev,
+               libgrantlee5-dev,
                libkf5archive-dev (>= 5.16.0),
                libkf5config-dev (>= 5.16.0),
+               libkf5declarative-dev (>= 5.16.0),
                libkf5guiaddons-dev (>= 5.16.0),
-               libkf5declarative-dev (>= 5.16.0),
                libkf5i18n-dev (>= 5.16.0),
                libkf5iconthemes-dev (>= 5.16.0),
                libkf5itemmodels-dev (>= 5.16.0),
                libkf5itemviews-dev (>= 5.16.0),
                libkf5jobwidgets-dev (>= 5.16.0),
                libkf5kcmutils-dev (>= 5.16.0),
-               libkf5kio-dev (>= 5.16.0),
                libkf5newstuff-dev (>= 5.16.0),
                libkf5notifications-dev (>= 5.16.0),
                libkf5notifyconfig-dev (>= 5.16.0),
@@ -31,18 +30,19 @@
                libkf5sonnet-dev (>= 5.16.0),
                libkf5texteditor-dev (>= 5.16.0),
                libkf5threadweaver-dev (>= 5.16.0),
+               libkf5widgetsaddons-dev (>= 5.16.0),
                libkf5windowsystem-dev (>= 5.16.0),
-               libkf5widgetsaddons-dev (>= 5.16.0),
                libkf5xmlgui-dev (>= 5.16.0),
-               libgrantlee5-dev,
                libkomparediff2-dev,
-               libboost-serialization-dev,
+               libqt5webkit5-dev (>= 5.4.0),
                libsvn-dev,
                pkg-kde-tools (>= 0.15.16),
+               qtbase5-dev (>= 5.4.0),
+               qtdeclarative5-dev (>= 5.4.0)
 Standards-Version: 3.9.8
 Homepage: http://www.kdevelop.org/
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-std/kdevplatform.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-kde/kde-std/kdevplatform.git
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevplatform
+Vcs-Git: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevplatform
 
 Package: kdevplatform10-libs
 Architecture: any
@@ -72,9 +72,7 @@
 Section: libdevel
 Architecture: any
 Depends: kdevplatform10-libs (= ${binary:Version}),
-         ${misc:Depends},
-         qtbase5-dev (>= 5.4.0),
-         qtdeclarative5-dev (>= 5.4.0),
+         libgrantlee5-dev,
          libkf5archive-dev (>= 5.16.0),
          libkf5config-dev (>= 5.16.0),
          libkf5guiaddons-dev (>= 5.16.0),
@@ -92,7 +90,9 @@
          libkf5texteditor-dev (>= 5.16.0),
          libkf5threadweaver-dev (>= 5.16.0),
          libkf5windowsystem-dev (>= 5.16.0),
-         libgrantlee5-dev,
+         qtbase5-dev (>= 5.4.0),
+         qtdeclarative5-dev (>= 5.4.0),
+         ${misc:Depends}
 Breaks: libsublime-dev (<< 5.0)
 Replaces: libsublime-dev (<< 5.0)
 Description: development files for the KDevelop platform
